diff --git a/roms/ipxe/src/tests/crc32_test.c b/roms/ipxe/src/tests/crc32_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..873f633a5502ac3adde59b65b03d2ca7b78989f3
--- /dev/null
+++ b/roms/ipxe/src/tests/crc32_test.c
@@ -0,0 +1,116 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * CRC32 tests
+ *
+ *
+ * Test vectors generated using Perl's Digest::CRC:
+ *
+ *    use Digest::CRC qw ( crc );
+ *
+ *    printf "%#08x", crc ( $data, 32, $seed, 0, 1, 0x04c11db7, 1 );
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stdint.h>
+#include <ipxe/crc32.h>
+#include <ipxe/test.h>
+
+/** Define inline data */
+#define DATA(...) { __VA_ARGS__ }
+
+/** A CRC32 test */
+struct crc32_test {
+	/** Test data */
+	const void *data;
+	/** Length of test data */
+	size_t len;
+	/** Seed */
+	uint32_t seed;
+	/** Expected CRC32 */
+	uint32_t crc32;
+};
+
+/**
+ * Define a CRC32 test
+ *
+ * @v name		Test name
+ * @v DATA		Test data
+ * @v SEED		Seed
+ * @v CRC32		Expected CRC32
+ * @ret test		CRC32 test
+ */
+#define CRC32_TEST( name, DATA, SEED, CRC32 )				\
+	static const uint8_t name ## _data[] = DATA;			\
+	static struct crc32_test name = {				\
+		.data = name ## _data,					\
+		.len = sizeof ( name ## _data ),			\
+		.seed = SEED,						\
+		.crc32 = CRC32,						\
+	};
+
+/**
+ * Report a CRC32 test result
+ *
+ * @v test		CRC32 test
+ */
+#define crc32_ok( test ) do {						\
+	uint32_t crc32;							\
+	crc32 = crc32_le ( (test)->seed, (test)->data, (test)->len );	\
+	ok ( crc32 == (test)->crc32 );					\
+	} while ( 0 )
+
+/* CRC32 tests */
+CRC32_TEST ( empty_test,
+	     DATA ( ),
+	     0x12345678UL, 0x12345678UL );
+CRC32_TEST ( hw_test,
+	     DATA ( 'h', 'e', 'l', 'l', 'o', ' ', 'w', 'o', 'r', 'l', 'd' ),
+	     0xffffffffUL, 0xf2b5ee7aUL );
+CRC32_TEST ( hw_split_part1_test,
+	     DATA ( 'h', 'e', 'l', 'l', 'o' ),
+	     0xffffffffUL, 0xc9ef5979UL );
+CRC32_TEST ( hw_split_part2_test,
+	     DATA ( ' ', 'w', 'o', 'r', 'l', 'd' ),
+	     0xc9ef5979UL, 0xf2b5ee7aUL );
+
+/**
+ * Perform CRC32 self-tests
+ *
+ */
+static void crc32_test_exec ( void ) {
+
+	crc32_ok ( &empty_test );
+	crc32_ok ( &hw_test );
+	crc32_ok ( &hw_split_part1_test );
+	crc32_ok ( &hw_split_part2_test );
+}
+
+/** CRC32 self-test */
+struct self_test crc32_test __self_test = {
+	.name = "crc32",
+	.exec = crc32_test_exec,
+};
diff --git a/roms/ipxe/src/tests/digest_test.c b/roms/ipxe/src/tests/digest_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..6428cc72820f0037b6965f76135d8e331e185d4a
--- /dev/null
+++ b/roms/ipxe/src/tests/digest_test.c
@@ -0,0 +1,105 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Digest self-tests
+ *
+ */
+
+#include <stdlib.h>
+#include <string.h>
+#include <ipxe/crypto.h>
+#include <ipxe/profile.h>
+#include "digest_test.h"
+
+/**
+ * Test digest algorithm
+ *
+ * @v digest		Digest algorithm
+ * @v fragments		Digest test fragment list, or NULL
+ * @v data		Test data
+ * @v len		Length of test data
+ * @v expected		Expected digest value
+ * @ret ok		Digest value is as expected
+ */
+int digest_test ( struct digest_algorithm *digest,
+		  struct digest_test_fragments *fragments,
+		  void *data, size_t len, void *expected ) {
+	uint8_t ctx[digest->ctxsize];
+	uint8_t out[digest->digestsize];
+	size_t frag_len = 0;
+	unsigned int i;
+
+	/* Initialise digest */
+	digest_init ( digest, ctx );
+
+	/* Update digest fragment-by-fragment */
+	for ( i = 0 ; len && ( i < ( sizeof ( fragments->len ) /
+				     sizeof ( fragments->len[0] ) ) ) ; i++ ) {
+		if ( fragments )
+			frag_len = fragments->len[i];
+		if ( ( frag_len == 0 ) || ( frag_len < len ) )
+			frag_len = len;
+		digest_update ( digest, ctx, data, frag_len );
+		data += frag_len;
+		len -= frag_len;
+	}
+
+	/* Finalise digest */
+	digest_final ( digest, ctx, out );
+
+	/* Compare against expected output */
+	return ( memcmp ( expected, out, sizeof ( out ) ) == 0 );
+}
+
+/**
+ * Calculate digest algorithm cost
+ *
+ * @v digest		Digest algorithm
+ * @ret cost		Cost (in cycles per byte)
+ */
+unsigned long digest_cost ( struct digest_algorithm *digest ) {
+	static uint8_t random[8192]; /* Too large for stack */
+	uint8_t ctx[digest->ctxsize];
+	uint8_t out[digest->digestsize];
+	union profiler profiler;
+	unsigned long long elapsed;
+	unsigned long cost;
+	unsigned int i;
+
+	/* Fill buffer with pseudo-random data */
+	srand ( 0x1234568 );
+	for ( i = 0 ; i < sizeof ( random ) ; i++ )
+		random[i] = rand();
+
+	/* Time digest calculation */
+	profile ( &profiler );
+	digest_init ( digest, ctx );
+	digest_update ( digest, ctx, random, sizeof ( random ) );
+	digest_final ( digest, ctx, out );
+	elapsed = profile ( &profiler );
+
+	/* Round to nearest whole number of cycles per byte */
+	cost = ( ( elapsed + ( sizeof ( random ) / 2 ) ) / sizeof ( random ) );
+
+	return cost;
+}
diff --git a/roms/ipxe/src/tests/digest_test.h b/roms/ipxe/src/tests/digest_test.h
new file mode 100644
index 0000000000000000000000000000000000000000..49e06d1cbc237a720ea6ca299471cef4c72924bb
--- /dev/null
+++ b/roms/ipxe/src/tests/digest_test.h
@@ -0,0 +1,37 @@
+#ifndef _DIGEST_TEST_H
+#define _DIGEST_TEST_H
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdint.h>
+#include <ipxe/crypto.h>
+#include <ipxe/test.h>
+
+/** Maximum number of digest test fragments */
+#define NUM_DIGEST_TEST_FRAG 8
+
+/** A digest test fragment list */
+struct digest_test_fragments {
+	/** Fragment lengths */
+	size_t len[NUM_DIGEST_TEST_FRAG];
+};
+
+extern int digest_test ( struct digest_algorithm *digest,
+			 struct digest_test_fragments *fragments,
+			 void *data, size_t len, void *expected );
+extern unsigned long digest_cost ( struct digest_algorithm *digest );
+
+/**
+ * Report digest test result
+ *
+ * @v digest		Digest algorithm
+ * @v fragments		Digest test fragment list, or NULL
+ * @v data		Test data
+ * @v len		Length of test data
+ * @v expected		Expected digest value
+ */
+#define digest_ok( digest, fragments, data, len, expected ) do {	\
+	ok ( digest_test ( digest, fragments, data, len, expected ) );	\
+	} while ( 0 )
+
+#endif /* _DIGEST_TEST_H */
diff --git a/roms/ipxe/src/tests/entropy_sample.c b/roms/ipxe/src/tests/entropy_sample.c
new file mode 100644
index 0000000000000000000000000000000000000000..95a662e3ec0b1d453969ecf7d0108122f35e6c8a
--- /dev/null
+++ b/roms/ipxe/src/tests/entropy_sample.c
@@ -0,0 +1,72 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Entropy sampling
+ *
+ */
+
+#include <stdio.h>
+#include <ipxe/entropy.h>
+#include <ipxe/test.h>
+
+/** Total number of test samples */
+#define SAMPLE_COUNT 65536
+
+/** Number of samples per block */
+#define SAMPLE_BLOCKSIZE 256
+
+/**
+ * Generate entropy samples for external testing
+ *
+ */
+static void entropy_sample_test_exec ( void ) {
+	static noise_sample_t samples[SAMPLE_BLOCKSIZE];
+	unsigned int i;
+	unsigned int j;
+	int rc;
+
+	/* Collect and print blocks of samples */
+	for ( i = 0 ; i < ( SAMPLE_COUNT / SAMPLE_BLOCKSIZE ) ; i++ ) {
+
+		/* Collect one block of samples */
+		rc = entropy_enable();
+		ok ( rc == 0 );
+		for ( j = 0 ; j < SAMPLE_BLOCKSIZE ; j++ ) {
+			rc = get_noise ( &samples[j] );
+			ok ( rc == 0 );
+		}
+		entropy_disable();
+
+		/* Print out sample values */
+		for ( j = 0 ; j < SAMPLE_BLOCKSIZE ; j++ ) {
+			printf ( "SAMPLE %d %d\n", ( i * SAMPLE_BLOCKSIZE + j ),
+				 samples[j] );
+		}
+	}
+}
+
+/** Entropy sampling self-test */
+struct self_test entropy_sample_test __self_test = {
+	.name = "entropy_sample",
+	.exec = entropy_sample_test_exec,
+};
